<template>
  <CallType
    v-if="props.messageData.type == 'missCall'"
    :date="messageData.date"
  ></CallType>
  <div
    v-else
    class="card-message"
    :class="{
      'me-card-message': messageData.itsMe,
      'is-selected-card': isSelected,
      'show-select-option': isSelectState,
    }"
    ref="targetContextMenuEvent"
    @contextmenu="preventOpenMenu"
  >
    <div
      class="card-message-container"
      :class="{
        'is-my-self-container': messageData.itsMe,
        'size-for-audio-container': messageData.type == 'audio',
      }"
      @click="emitToSetSelectedItems"
    >
      <div class="header-parts">
        <!-- Is Forwarded Part -->
        <div class="is-forwarded column-flex mb-5" v-if="false">
          <span>{{ t('tabs.message.chatCard.isForwarded') }}</span>
          <span>{{ forwardedData.targetUsername }}</span>
        </div>
        <!-- Is Replied Part -->
        <ReplyType
          @click="handlerForScrollTarget"
          v-if="messageData.repliedData"
          :repliedData="messageData.repliedData"
          :name="name"
          :type="messageData.type"
        ></ReplyType>
      </div>
      <!--  -->
      <ImageType
        v-if="messageData.type == 'image'"
        :messageData="messageData"
        :blobFilePath="blobFilePath"
        :mainDownloadState="mainDownloadState"
        @downloadMainMediaFile="downloadMainMediaFile('image')"
      ></ImageType>
      <!--  -->
      <VideoType
        v-if="messageData.type == 'video'"
        :messageData="messageData"
        :blobFilePath="blobFilePath"
        :videoBlobPath="videoBlobPath"
        :mainDownloadState="mainDownloadState"
        @downloadMainMediaFile="downloadMainMediaFile('video')"
      ></VideoType>
      <!--  -->
      <AudioType
        v-if="messageData.type == 'audio'"
        :blobFilePath="blobFilePath"
      >
      </AudioType>
      <!--  -->
      <FileType
        v-if="messageData.type == 'file'"
        :blobFilePath="blobFilePath"
        :fileInfo="{
          ...messageData.additionalFileInfo,
          content: messageData.content,
        }"
        :mainDownloadState="mainDownloadState"
        class="file-container"
      ></FileType>
      <!--  -->
      <div
        class="text-message"
        v-if="messageData.type == 'text'"
        :class="{
          'text-direction-right': messageData.textDirectionIsRtl,
          'font-farsi': messageData.textDirectionIsRtl,
          'text-direction-left': !messageData.textDirectionIsRtl,
        }"
        v-html="messageData.content"
      ></div>
      <TimeAndState
        v-if="!['image', 'video'].includes(messageData.type)"
        :date="messageData.date"
        :itsMe="messageData.itsMe"
        :status="messageData.status"
      ></TimeAndState>
    </div>
    <div class="select-chat-container" @click="emitToSetSelectedItems">
      <div class="default-circle"></div>
      <IonIcon
        :icon="checkmarkCircle"
        color="success"
        class="checkmark-icon"
        :class="{ 'checkmark-icon-active': isSelected }"
      ></IonIcon>
    </div>
  </div>
</template>

<script setup>
import { popoverController, IonIcon } from '@ionic/vue';
import { ref, onMounted, defineProps, defineEmits } from 'vue';
import { useI18n } from 'vue-i18n';
import { useFileManagerStore } from '@/store/fileManager/fileManager.js';
import TimeAndState from '@/components/message/basics/MessageCard/TimeAndState.vue';
import CallType from '@/components/message/basics/MessageCard/CallType.vue';
import ImageType from '@/components/message/basics/MessageCard/ImageType.vue';
import VideoType from '@/components/message/basics/MessageCard/VideoType.vue';
import AudioType from '@/components/message/basics/MessageCard/AudioType.vue';
import FileType from '@/components/message/basics/MessageCard/FileType.vue';
import ReplyType from '@/components/message/basics/MessageCard/ReplyType.vue';
import ContextMenuPopover from '@/components/message/basics/MessageCard/ContextMenuPopover.vue';
import { onLongPress } from '@vueuse/core';
import { checkmarkCircle } from 'ionicons/icons';

const { t } = useI18n();

const props = defineProps({
  messageData: {
    type: Object,
    default: () => {
      return {
        id: '',
        itsMe: false,
        type: 'text', // as detecting type for downloading
        content: '',
        date: '',
        status: 'sent',
        editedInfo: {
          isEdited: false,
          date: '',
        },
        textDirectionIsRtl: null,
        imageHeight: null,
      };
    },
  },
  name: {
    type: String,
    default: '',
  },
  isSelected: {
    type: Boolean,
    default: false,
  },
  isSelectState: {
    type: Boolean,
    default: false,
  },
});
const emit = defineEmits([
  'onReply',
  'onCopy',
  'onForward',
  'onRemove',
  'onScrollToTargetChat',
  'setActiveSelectState',
  'setSelectedItems',
]);

const blobFilePath = ref(null);
const videoBlobPath = ref(null);

const mainDownloadState = ref('requestNotSent');
const downloadMainFile = async (type) => {
  const fileManagerStore = useFileManagerStore();
  // await fileManagerStore.getAllSystemFiles();
  const file = await fileManagerStore.handlerForGettingFile(
    props.messageData.content,
    type,
  );

  blobFilePath.value = file.filePath;
};
const downloadMainMediaFile = async (type = 'image') => {
  mainDownloadState.value = 'downloading';
  const fileManagerStore = useFileManagerStore();
  const file = await fileManagerStore.handlerForGettingFile(
    props.messageData.content,
    type,
  );
  blobFilePath.value = file.filePath;
  if (type == 'video') {
    videoBlobPath.value = file.filePath;
  }
  mainDownloadState.value = 'downloaded';
};
const downloadThumbnailFile = async (type = 'image') => {
  const fileManagerStore = useFileManagerStore();
  const file = await fileManagerStore.handlerForGettingFile(
    props.messageData.content,
    type,
    true,
  );
  blobFilePath.value = file.filePath;
  if (file.itsMain) mainDownloadState.value = 'downloaded';
};
const openContextMenu = async (event) => {
  event.preventDefault();
  if (props.isSelectState) return;
  const popover = await popoverController.create({
    component: ContextMenuPopover,
    event: event,
  });
  await popover.present();

  const { data, role } = await popover.onDidDismiss();
  if (role == 'confirm') {
    emit(data, props.messageData);
  }
};
const preventOpenMenu = (event) => {
  event.preventDefault();
};
const handlerForScrollTarget = () => {
  emit('onScrollToTargetChat', props.messageData.repliedData.targetMessageId);
};
const emitToSetSelectedItems = () => {
  if (props.isSelectState) emit('setSelectedItems', props.messageData);
};
onMounted(() => {
  if (!['missCall', 'text'].includes(props.messageData.type)) {
    if (props.messageData.previewState) {
      mainDownloadState.value = 'downloaded';
      blobFilePath.value = props.messageData.previewState;
      return;
    }
    switch (props.messageData.type) {
      case 'image':
        downloadThumbnailFile('image');
        break;
      case 'video':
        downloadThumbnailFile('video');
        break;
      case 'audio':
        downloadMainFile('audio');
        break;
      case 'file':
        //   fileDownloadStateHandler();
        break;

      default:
        break;
    }
  }
});

const targetContextMenuEvent = ref(null);
onLongPress(targetContextMenuEvent, openContextMenu, {
  modifiers: {
    prevent: false,
  },
});
</script>

<style scoped>
.card-message-container {
  --card-container-background: var(--ion-color-bg-input);
  --card-container-color: var(--ion-color-dark);
  --card-forwarded-color: var(--ion-color-primary-shade);
  --card-replied-background: #0066ff1a;
  --card-replied-color-user: var(--ion-color-primary);
  --card-replied-color-message: var(--ion-color-secondary);
  --card-image-skleton-background: #d8d8d8;
  --card-image-skleton-loader: #f3f3f375;
  --card-time-color: var(--ion-color-medium);
  --card-time-color-in-image: #292525;
}
.is-my-self-container {
  --card-container-background: var(--ion-color-success-tint);
  --card-container-color: var(--ion-color-black);
  --card-forwarded-color: var(--ion-color-primary-shade);
  --card-replied-background: var(--ion-color-success);
  --card-replied-color-user: var(--ion-color-primary);
  --card-replied-color-message: var(--ion-color-primary-shade);
  --card-image-skleton-background: #bce7e2;
  --card-image-skleton-loader: #b4ffbe70;
  --card-time-color: var(--ion-color-medium);
  --card-time-color-in-image: #292525;
}

.card-message {
  display: flex;
  justify-content: flex-end;
  flex-direction: row-reverse;
  align-items: center;
  padding: 5px 0;
  transition: 0.3s;
  transform: translateX(-30px);
}
.me-card-message {
  justify-content: flex-end;
  flex-direction: row;
  transform: translateX(30px);
  transition: 0.3s;
}
.show-select-option {
  transform: translateX(0px);
}

.card-message-container {
  min-height: 45px;
  max-width: 80vw;
  min-width: 50px;
  background-color: var(--card-container-background);
  color: var(--card-container-color);
  padding: 5px;
  border-radius: 15px;
  border-bottom-left-radius: 0;
  font-size: 15px;
  position: relative;
  margin-bottom: 10حط;
}
.is-selected-card {
  background-color: #428cff33;
}
.is-my-self-container {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 0;
}

/* Header Parts Start  */

.is-forwarded {
  font-size: 10px;
  color: var(--card-forwarded-color);
}

/* Header Parts end  */

/* Content Part Start */

.size-for-audio-container {
  width: 70vw;
}
.ios .size-for-audio-container {
  width: 70vw;
}

.text-message {
  min-height: 22px;
}
/* Content Part End */
/* helper css Classes  */
.column-flex {
  display: flex;
  flex-direction: column;
}
.height-width-100 {
  width: 100%;
  height: 100%;
}
.font-farsi {
  font-family: Yekan Bakh FaNum;
}
.select-chat-container {
  width: 13px;
  height: 13px;
  position: relative;
  margin-left: 16px;
  margin-right: 16px;
}

.default-circle {
  width: 13px;
  height: 13px;
  border: white 1px solid;
  border-radius: 50px;
  animation-fill-mode: both;
  background: var(--ion-color-secondary);
  position: relative;
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
}
.checkmark-icon {
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  transition: 0.2s;
  opacity: 0;
  /* border: 1px solid white; */
  border-radius: 50%;
  width: 13px;
  height: 13px;
}
.checkmark-icon-active {
  opacity: 1;
  fill: var(--ion-color-success);
}
</style>
